package com.dky.calculate;


import com.dky.utils.entity.SysDeviceHeatScene;
import com.dky.utils.result.MatchedDevice;

import java.util.*;
import java.util.stream.Collectors;

public class KitchenCookScheme {

    public static List<MatchedDevice> getCookDevices(Integer peopleNum, List<SysDeviceHeatScene> sysDeviceHeatSceneList) {
        // 获取烹饪设备类型最少推荐使用人数
        Integer cookDeviceType = getCookDeviceType(peopleNum, sysDeviceHeatSceneList);

        List<SysDeviceHeatScene> collect = sysDeviceHeatSceneList.stream().filter(SysDeviceHeatScene -> Objects.equals(SysDeviceHeatScene.getRecomMinPeopleNum(), cookDeviceType)).collect(Collectors.toList());

        List<MatchedDevice> list = new ArrayList<>();

        collect.forEach((device) ->{
            list.add(new MatchedDevice(1, device));
        });

       return list;
    }

    public static Integer getCookDeviceType(Integer peopleNum, List<SysDeviceHeatScene> sysDeviceHeatSceneList) {
        ArrayList<SysDeviceHeatScene> collect = sysDeviceHeatSceneList.stream().collect(
                Collectors.collectingAndThen(
                        Collectors.toCollection(() -> new TreeSet<>(Comparator.comparing(SysDeviceHeatScene::getRecomMinPeopleNum))),
                        ArrayList::new
                )
        );

        IntSummaryStatistics intSummaryStatistics = collect.stream().mapToInt(SysDeviceHeatScene::getRecomMinPeopleNum).summaryStatistics();

        for (SysDeviceHeatScene s : collect){
            if (s.getRecomMinPeopleNum() >= intSummaryStatistics.getMax()){
                return s.getRecomMinPeopleNum();
            } else {
                boolean f1 = peopleNum >= s.getRecomMinPeopleNum();
                boolean f2 = peopleNum <= s.getRecomMaxPeopleNum();
                if (f1 && f2){
                    return s.getRecomMinPeopleNum();
                }
            }
        }
        return 1;
    }




}
